/*
* Koejke v.2 (Biscottini)
* https://koekje-js.de
*
* Copyright 2023 Christian Holmok
* Contribution by Jan-Erik Andersen
* Released under the MIT license
*/

jQuery(function ($) {
    let koekjeURL;
    const koekjeVersion = "v.2.0.1 (Biscottini)";

    let htmllang = $("html").attr("lang");
    let koekjeType;
    let koekjeSelectors = 0;
    let koekjeBtnFont;
    window.koekje = function (options) {
        const plugin = this;
        plugin.settings = Object.assign({}, options);
        const koekjeLang = plugin.settings.widget.language;
        
        console.log(`%ckoekje - Der Cookie-Manager mit Stückchen - ${koekjeVersion} (${koekjeLang}) - koekje-js.de`, "background: #BDC7BD; color: #424952; display: block;font-weight: bold;padding: 5px; font-size:10px;border-radius:5px;text-align:center");
        const tryCatchAssign = (variable, defaultValue) => {
            try {
                return variable;
            } catch (err) {
                return defaultValue;
            } 
        };

        // ##################################################################### //
        // ###################### read user configuration ###################### //
        // ##################################################################### //

        // ------- Services ------- //

        

        let koekje_id = tryCatchAssign(plugin.settings.koekje_id, undefined);

        let GoogleAnalytics = tryCatchAssign(plugin.settings.services.GoogleAnalytics, undefined);
        let GoogleLoadOnTop = tryCatchAssign(plugin.settings.google.loadOnTop, undefined);
        let SoundCloud = tryCatchAssign(plugin.settings.services.SoundCloud, undefined);
        let YouTube = tryCatchAssign(plugin.settings.services.YouTube, undefined);
        let Facebook = tryCatchAssign(plugin.settings.services.Facebook, undefined);
        let FacebookMarketing = tryCatchAssign(plugin.settings.services.FacebookMarketing, undefined);
        let Adform = tryCatchAssign(plugin.settings.services.Adform, undefined);
        let AdformPM = tryCatchAssign(plugin.settings.adform?.pm, undefined);
        let AdformPageName = tryCatchAssign(plugin.settings.adform?.pagename, undefined);
        let Twitter = tryCatchAssign(plugin.settings.services.Twitter, undefined);
        let Vimeo = tryCatchAssign(plugin.settings.services.Vimeo, undefined);
        let Matomo = tryCatchAssign(plugin.settings.services.Matomo, undefined);
        let Spotify = tryCatchAssign(plugin.settings.services.Spotify, undefined);
        let GoogleMaps = tryCatchAssign(plugin.settings.services.GoogleMaps, undefined);
        let Userlike = tryCatchAssign(plugin.settings.services.Userlike, undefined);
        let Instagram = tryCatchAssign(plugin.settings.services.Instagram, undefined);
        let Issuu = tryCatchAssign(plugin.settings.services.Issuu, undefined);
        let Yumpu = tryCatchAssign(plugin.settings.services.Yumpu, undefined);
        let googleID = tryCatchAssign(plugin.settings.google.googleID, undefined);
        let googletagmanagerID = tryCatchAssign(plugin.settings.google.googletagmanagerID, undefined);
        let facebookID = tryCatchAssign(plugin.settings.facebookmarketing?.facebookmarketingID, undefined);
        let facebookCurrency = tryCatchAssign(plugin.settings.facebookmarketing?.currency, undefined);
        let mapsKey = tryCatchAssign(plugin.settings.google.mapsKey, undefined);
        let mapsFunction = tryCatchAssign(plugin.settings.google.mapsFunction, undefined);

        // Custom
        let custom1 = tryCatchAssign(plugin.settings.custom?.custom1, undefined);
        let custom1title = tryCatchAssign(plugin.settings.custom?.custom1?.title, undefined);
        let custom1description = tryCatchAssign(plugin.settings.custom?.custom1?.description, undefined);
        let custom1script = tryCatchAssign(plugin.settings.custom?.custom1?.script, undefined);
        let custom1essential = tryCatchAssign(plugin.settings.custom?.custom1?.essential, undefined);
        let custom1type = tryCatchAssign(plugin.settings.custom?.custom1?.type, undefined);
        let custom2 = tryCatchAssign(plugin.settings.custom?.custom2, undefined);
        let custom2title = tryCatchAssign(plugin.settings.custom?.custom2?.title, undefined);
        let custom2description = tryCatchAssign(plugin.settings.custom?.custom2?.description, undefined);
        let custom2script = tryCatchAssign(plugin.settings.custom?.custom2?.script, undefined);
        let custom2essential = tryCatchAssign(plugin.settings.custom?.custom2?.essential, undefined);
        let custom2type = tryCatchAssign(plugin.settings.custom?.custom2?.type, undefined);
        let custom3 = tryCatchAssign(plugin.settings.custom?.custom3, undefined);
        let custom3title = tryCatchAssign(plugin.settings.custom?.custom3?.title, undefined);
        let custom3description = tryCatchAssign(plugin.settings.custom?.custom3?.description, undefined);
        let custom3script = tryCatchAssign(plugin.settings.custom?.custom3?.script, undefined);
        let custom3essential = tryCatchAssign(plugin.settings.custom?.custom3?.essential, undefined);
        let custom3type = tryCatchAssign(plugin.settings.custom?.custom3?.type, undefined);
        let custom4 = tryCatchAssign(plugin.settings.custom?.custom4, undefined);
        let custom4title = tryCatchAssign(plugin.settings.custom?.custom4?.title, undefined);
        let custom4description = tryCatchAssign(plugin.settings.custom?.custom4?.description, undefined);
        let custom4script = tryCatchAssign(plugin.settings.custom?.custom4?.script, undefined);
        let custom4essential = tryCatchAssign(plugin.settings.custom?.custom4?.essential, undefined);
        let custom4type = tryCatchAssign(plugin.settings.custom?.custom4?.type, undefined);
        let custom5 = tryCatchAssign(plugin.settings.custom?.custom5, undefined);
        let custom5title = tryCatchAssign(plugin.settings.custom?.custom5?.title, undefined);
        let custom5description = tryCatchAssign(plugin.settings.custom?.custom5?.description, undefined);
        let custom5script = tryCatchAssign(plugin.settings.custom?.custom5?.script, undefined);
        let custom5essential = tryCatchAssign(plugin.settings.custom?.custom5?.essential, undefined);
        let custom5type = tryCatchAssign(plugin.settings.custom?.custom5?.type, undefined);
        let custom6 = tryCatchAssign(plugin.settings.custom?.custom6, undefined);
        let custom6title = tryCatchAssign(plugin.settings.custom?.custom6?.title, undefined);
        let custom6description = tryCatchAssign(plugin.settings.custom?.custom6?.description, undefined);
        let custom6script = tryCatchAssign(plugin.settings.custom?.custom6?.script, undefined);
        let custom6essential = tryCatchAssign(plugin.settings.custom?.custom6?.essential, undefined);
        let custom6type = tryCatchAssign(plugin.settings.custom?.custom6?.type, undefined);
        let custom7 = tryCatchAssign(plugin.settings.custom?.custom7, undefined);
        let custom7title = tryCatchAssign(plugin.settings.custom?.custom7?.title, undefined);
        let custom7description = tryCatchAssign(plugin.settings.custom?.custom7?.description, undefined);
        let custom7script = tryCatchAssign(plugin.settings.custom?.custom7?.script, undefined);
        let custom7essential = tryCatchAssign(plugin.settings.custom?.custom7?.essential, undefined);
        let custom7type = tryCatchAssign(plugin.settings.custom?.custom7?.type, undefined);
        let custom8 = tryCatchAssign(plugin.settings.custom?.custom8, undefined);
        let custom8title = tryCatchAssign(plugin.settings.custom?.custom8?.title, undefined);
        let custom8description = tryCatchAssign(plugin.settings.custom?.custom8?.description, undefined);
        let custom8script = tryCatchAssign(plugin.settings.custom?.custom8?.script, undefined);
        let custom8essential = tryCatchAssign(plugin.settings.custom?.custom8?.essential, undefined);
        let custom8type = tryCatchAssign(plugin.settings.custom?.custom8?.type, undefined);
        let custom9 = tryCatchAssign(plugin.settings.custom?.custom9, undefined);
        let custom9title = tryCatchAssign(plugin.settings.custom?.custom9?.title, undefined);
        let custom9description = tryCatchAssign(plugin.settings.custom?.custom9?.description, undefined);
        let custom9script = tryCatchAssign(plugin.settings.custom?.custom9?.script, undefined);
        let custom9essential = tryCatchAssign(plugin.settings.custom?.custom9?.essential, undefined);
        let custom9type = tryCatchAssign(plugin.settings.custom?.custom9?.type, undefined);
        let custom10 = tryCatchAssign(plugin.settings.custom?.custom10, undefined);
        let custom10title = tryCatchAssign(plugin.settings.custom?.custom10?.title, undefined);
        let custom10description = tryCatchAssign(plugin.settings.custom?.custom10?.description, undefined);
        let custom10script = tryCatchAssign(plugin.settings.custom?.custom10?.script, undefined);
        let custom10essential = tryCatchAssign(plugin.settings.custom?.custom10?.essential, undefined);
        let custom10type = tryCatchAssign(plugin.settings.custom?.custom10?.type, undefined);

        // Widget
        let koekjePosition = tryCatchAssign(plugin.settings.widget.position, undefined);
        let koekjeLayout = tryCatchAssign(plugin.settings.widget.layout, undefined);
        let koekjeMode = tryCatchAssign(plugin.settings.widget.mode, undefined);
        let koekjeBackgroundStyle = tryCatchAssign(plugin.settings.widget.background, undefined);
        let koekjeBackgroundColor = tryCatchAssign(plugin.settings.widget.color?.background, undefined);
        let koekjeTextColor = tryCatchAssign(plugin.settings.widget.color?.text, undefined);
        let koekjeButtonColor = tryCatchAssign(plugin.settings.widget.color?.button, undefined);
        let koekjeSliderColor = tryCatchAssign(plugin.settings.widget.color?.slider, undefined);
        let koekjePlaceholder = tryCatchAssign(plugin.settings.placeholder, undefined);
        let koekjeFonts = tryCatchAssign(plugin.settings.widget.fonts, undefined);
        let koekjeHeadlineBool = tryCatchAssign(plugin.settings.widget.headline, undefined);
        let koekjeLogo = tryCatchAssign(plugin.settings.widget.logo, undefined);
        let curtain = tryCatchAssign(plugin.settings.widget.curtain, undefined);
        let curtainOpacity = tryCatchAssign(plugin.settings.widget.curtainOpacity, undefined);
        let cornerCookie = tryCatchAssign(plugin.settings.widget.cornerCookie, undefined);
        let cornerCookieColor = tryCatchAssign(plugin.settings.widget.cornerCookieColor, undefined);
        let showonImprint = tryCatchAssign(plugin.settings.widget.showonImprint, undefined);
        let shadow = tryCatchAssign(plugin.settings.widget.shadow, undefined);

        let koekjeprivacyLinkURL = tryCatchAssign(plugin.settings.widget.privacyLinkURL, undefined);
        let koekjeimprintLinkURL = tryCatchAssign(plugin.settings.widget.imprintLinkURL, undefined);
        

        let shadowMode = tryCatchAssign(plugin.settings.widget.shadowMode, undefined);
        let pointer = tryCatchAssign(plugin.settings.widget.blockedCurtain, undefined);

        // Text
        let mainlang = tryCatchAssign(plugin.settings.widget.language, undefined);
        let owntexts = tryCatchAssign(plugin.settings.widget.owntexts, undefined);

        
        
        

        // Definitions
        let showonPrivacy = tryCatchAssign(plugin.settings.widget.showonPrivacy, undefined);
        let switchButtons = tryCatchAssign(plugin.settings.widget.switchButtons, undefined);
        // TODO: Switchbuttons nutzen

        // Widget Footer
        let koekjeCreatorText = tryCatchAssign(plugin.settings.widget.CreatorText, undefined);

        let koekjeCreatorURL = tryCatchAssign(plugin.settings.widget.CreatorURL, undefined);
        if(!koekjeCreatorURL) {
            koekjeCreatorURL = "https://koekje-js.de"
        }

        // Essentials
        let koekjeVimeoEssential = tryCatchAssign(plugin.settings.essential?.Vimeo, undefined);
        let koekjeYouTubeEssential = tryCatchAssign(plugin.settings.essential?.YouTube, undefined);
        let koekjeFacebookEssential = tryCatchAssign(plugin.settings.essential?.Facebook, undefined);
        let koekjeTwitterEssential = tryCatchAssign(plugin.settings.essential?.Twitter, undefined);
        let koekjeSpotifyEssential = tryCatchAssign(plugin.settings.essential?.Spotify, undefined);
        let koekjeGoogleMapsEssential = tryCatchAssign(plugin.settings.essential?.GoogleMaps, undefined);
        let koekjeUserlikeEssential = tryCatchAssign(plugin.settings.essential?.Userlike, undefined);
        let koekjeInstagramEssential = tryCatchAssign(plugin.settings.essential?.Instagram, undefined);
        let koekjeIssuuEssential = tryCatchAssign(plugin.settings.essential?.Issuu, undefined);
        let koekjeMatomoEssential = tryCatchAssign(plugin.settings.essential?.Matomo, undefined);
        let koekjeYumpuEssential = tryCatchAssign(plugin.settings.essential?.Yumpu, undefined);
        let koekjeFacebookMarketingEssential = tryCatchAssign(plugin.settings.essential?.FacebookMarketing, undefined);
        let koekjeAdformEssential = tryCatchAssign(plugin.settings.essential?.Adform, undefined);
        let koekjeGoogleAnalyticsEssential = tryCatchAssign(plugin.settings.essential?.GoogleAnalytics, undefined);

        // Variables
        koekjeOrigin = koekjeCreatorText ? '<a href="' + koekjeCreatorURL + '">' + koekjeCreatorText + '</a> ' : 'Cookie Manager';
        var koekjeShadow = shadow ? "shadow " + shadowMode : "";
        var koekjePointer = pointer ? "pointer" : "";

        // Service Count
        let koekjeSelectors = [
            GoogleAnalytics,
            SoundCloud,
            YouTube,
            Facebook,
            FacebookMarketing,
            Adform,
            Vimeo,
            Issuu,
            Yumpu,
            Userlike,
            Twitter,
            GoogleMaps,
            Instagram,
            Matomo,
            custom1,
            custom2,
            custom3,
            custom4,
            custom5,
            custom6,
            custom7,
            custom8,
            custom9,
            custom10
        ].reduce((count, service) => count + (service !== undefined && service !== false ? 1 : 0), 0);



        if(owntexts == true) {
            
            if (htmllang == koekjeLang) {
                
                var koekjePrivacyLinkText = tryCatchAssign(plugin.settings.text.first.koekjePrivacyLinkText, undefined);
                if(!koekjePrivacyLinkText) {
                    var koekjePrivacyLinkText = "Datenschutzerklärung";
                }

                var koekjeImprintLinkText = tryCatchAssign(plugin.settings.text.first.koekjeImprintLinkText, undefined);
                if(!koekjeImprintLinkText) {
                    var koekjeImprintLinkText = "Impressum";
                }

                var koekjeHeadline = tryCatchAssign(plugin.settings.text.first.koekjeheadline, undefined);
                if(!koekjeHeadline) {
                    var koekjeHeadline = "Cookies & Dienste";
                }

                var koekjeSubheadline = tryCatchAssign(plugin.settings.text.first.koekjesubheadline, undefined);
                if(!koekjeSubheadline) {
                    var koekjeSubheadline = "Bitte wählen Sie, welche Dienste Sie automatisch zulassen möchten";
                }

                var koekjeButton = tryCatchAssign(plugin.settings.text.first.koekjebutton, undefined);
                if(!koekjeButton) {
                    var koekjeButton = "Alle akzeptieren";
                }

                var koekjeButtonSelection = tryCatchAssign(plugin.settings.text.first.koekjebuttonSelect, undefined);
                if(!koekjeButtonSelection) {
                    var koekjeButtonSelection = "Speichern";
                }

                var koekjeDetailChoice = tryCatchAssign(plugin.settings.text.first.koekjedetailSelect, undefined);
                if(!koekjeDetailChoice) {
                    var koekjeDetailChoice = "Details";
                }

                var koekjeCopy = tryCatchAssign(plugin.settings.text.first.koekjecopy, undefined);
                if(!koekjeCopy) {
                    var koekjeCopy = "Wir nutzen Cookies auf unserer Website. Einige von ihnen sind essenziell, während andere uns helfen, diese Website und Ihre Erfahrung zu verbessern.";
                }

                var koekjeAllowHeadline = tryCatchAssign(plugin.settings.text.first.koekjeallowHeadline, undefined);
                if(!koekjeAllowHeadline) {
                    var koekjeAllowHeadline = "Möchten Sie diese Inhalte immer erlauben?";
                }

                var koekjeAllowCopy = tryCatchAssign(plugin.settings.text.first.koekjeallowCopy, undefined);
                if(!koekjeAllowCopy) {
                    var koekjeAllowCopy = "Sie haben für diesen Inhaltstyp eine Ausnahme hinzugefügt. Möchten Sie diese Art Inhalt immer laden? Bei Bestätigung wird die Seite neu geladen.";
                }

                var koekjeAllowYes = tryCatchAssign(plugin.settings.text.first.koekjeallowYes, undefined);
                if(!koekjeAllowYes) {
                    var koekjeAllowYes = "Ja";
                }

                var koekjeAllowNo = tryCatchAssign(plugin.settings.text.first.koekjeallowNo, undefined);
                if(!koekjeAllowNo) {
                    var koekjeAllowNo = "Nein";
                }

                var koekjeAllowDoNotAsk = tryCatchAssign(plugin.settings.text.first.koekjeallowDoNotAsk, undefined);
                if(!koekjeAllowDoNotAsk) {
                    var koekjeAllowDoNotAsk = "Nicht mehr fragen";
                }

                var koekjeButtonText = tryCatchAssign(plugin.settings.text.first.koekjeallowButton, undefined);
                if(!koekjeButtonText) {
                    var koekjeButtonText = "Inhalte nachladen";
                }

                var koekjeButtonTextParagraph = tryCatchAssign(plugin.settings.text.first.koekjeallowButtonParagraph, undefined);
                if(!koekjeButtonTextParagraph) {
                    var koekjeButtonTextParagraph = "Erst wenn Sie hier klicken, werden Bilder und andere Daten von Drittanbietern nachgeladen. Ihre IP-Adresse wird dabei an externe Server (Facebook, Google, Instagram, Twitter, etc.) übertragen  und Cookies werden gesetzt. Über den Datenschutz dieser Anbieter können Sie sich auf den jeweiligen Seiten informieren.";
                }

                var koekjedescGoogleAnalytics = tryCatchAssign(plugin.settings.text.first.koekjedescGoogleAnalytics, undefined);
                if(!koekjedescGoogleAnalytics) {
                    var koekjedescGoogleAnalytics = "Google Analytics ist ein Trackingtool des US-Unternehmens Google, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                }

                var koekjedescYouTube = tryCatchAssign(plugin.settings.text.first.koekjedescYouTube, undefined);
                if(!koekjedescYouTube) {
                    var koekjedescYouTube = "YouTube ist eine Video-Plattform des US-Unternehmens Google, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                }

                var koekjedescSoundCloud = tryCatchAssign(plugin.settings.text.first.koekjedescSoundCloud, undefined);
                if(!koekjedescSoundCloud) {
                    var koekjedescSoundCloud = "SoundCloud ist ein Online-Musikdienst zum Austausch und zur Distribution von Audiodateien. Er dient als Kooperations- und Werbeplattform für Musiker";
                }

                var koekjedescFacebook = tryCatchAssign(plugin.settings.text.first.koekjedescFacebook, undefined);
                if(!koekjedescFacebook) {
                    var koekjedescFacebook = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                }

                var koekjedescFacebookMarketing = tryCatchAssign(plugin.settings.text.first.koekjedescFacebookMarketing, undefined);
                if(!koekjedescFacebookMarketing) {
                    var koekjedescFacebookMarketing = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden. Dies ist der FB-Pixel";
                }

                var koekjedescAdform = tryCatchAssign(plugin.settings.text.first.koekjedescAdform, undefined);
                if(!koekjedescAdform) {
                    var koekjedescAdform = "Adform ist ein dänisches Werbenetzwerk";
                }

                var koekjedescTwitter = tryCatchAssign(plugin.settings.text.first.koekjedescTwitter, undefined);
                if(!koekjedescTwitter) {
                    var koekjedescTwitter = "Twitter ist ein Mikrobloggingdienst für Kurznachrichten, das die Möglichkeit bietet, Profile, Tweets und die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                }

                var koekjedescVimeo = tryCatchAssign(plugin.settings.text.first.koekjedescVimeo, undefined);
                if(!koekjedescVimeo) {
                    var koekjedescVimeo = "Vimeo ist eine Video-Plattform, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                }

                var koekjedescSpotify = tryCatchAssign(plugin.settings.text.first.koekjedescSpotify, undefined);
                if(!koekjedescSpotify) {
                    var koekjedescSpotify = "Spotify ist ein Musik-Streamingdienst, der die Möglichkeit bietet, Profile, Playlisten und Songs auf externen Seiten einzubetten.";
                }

                var koekjedescGoogleMaps = tryCatchAssign(plugin.settings.text.first.koekjedescGoogleMaps, undefined);
                if(!koekjedescGoogleMaps) {
                    var koekjedescGoogleMaps = "Google Maps ist ein Kartendienst des US-Unternehmens Google, mit dem Routen, interaktive Karten und Kartenausschnitte auf Webseiten eingebettet werden können.";
                }

                var koekjedescInstagram = tryCatchAssign(plugin.settings.text.first.koekjedescInstagram, undefined);
                if(!koekjedescInstagram) {
                    var koekjedescInstagram = "Instagram ist ein soziales Netzwerk des US-Unternehens Facebook, das die Möglichkeit bietet, Bilder und Profile von Instagram auf anderen Seiten einzubetten.";
                }

                var koekjedescIssuu = tryCatchAssign(plugin.settings.text.first.koekjedescIssuu, undefined);
                if(!koekjedescIssuu) {
                    var koekjedescIssuu = "Issuu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                }

                var koekjedescYumpu = tryCatchAssign(plugin.settings.text.first.koekjedescYumpu, undefined);
                if(!koekjedescYumpu) {
                    var koekjedescYumpu = "Yumpu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                }

                var koekjedescMatomo = tryCatchAssign(plugin.settings.text.first.koekjedescMatomo, undefined);
                if(!koekjedescMatomo) {
                    var koekjedescMatomo = "Matomo (ehemals Piwik) ist ein Trackingtool, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                }

                var koekjedescUserlike = tryCatchAssign(plugin.settings.text.first.koekjedescUserlike, undefined);
                if(!koekjedescUserlike) {
                    var koekjedescUserlike = "Userlike ist ein Anbieter von Chat-Tools auf Webseiten. User können über ein eingebautes Chat-Fenster mit dem Support-Team einer Webseite in Kontakt treten oder in deren Abwesenheit eine Nachricht hinterlassen.";
                }
 
                var koekjeEssential = tryCatchAssign(plugin.settings.text.first.koekjeEssential, undefined);
                if(!koekjeEssential) {
                    var koekjeEssential = "Essentielle Cookies";
                }
                
                var koekjeStatistics = tryCatchAssign(plugin.settings.text.first.koekjeStatistics, undefined);
                if(!koekjeStatistics) {
                    var koekjeStatistics = "Statistiken";
                }

                var koekjeExtMedia = tryCatchAssign(plugin.settings.text.first.koekjeExtMedia, undefined);
                if(!koekjeExtMedia) {
                    var koekjeExtMedia = "Externe Medien";
                }

                var koekje3rdParty = tryCatchAssign(plugin.settings.text.first.koekje3rdParty, undefined);
                if(!koekje3rdParty) {
                    var koekje3rdParty = "Drittanbieter";
                }

                var cornerCookieText = tryCatchAssign(plugin.settings.text.first.koekjecornerCookieText, undefined);
                if(!cornerCookieText) {
                    var cornerCookieText = "Cookie Einstellungen anpassen";
                }
            } else {
                
                var koekjePrivacyLinkText = tryCatchAssign(plugin.settings.text.default.koekjePrivacyLinkText, undefined);
                if(!koekjePrivacyLinkText) {
                    var koekjePrivacyLinkText = "Datenschutzerklärung";
                }

                var koekjeImprintLinkText = tryCatchAssign(plugin.settings.text.default.koekjeImprintLinkText, undefined);
                if(!koekjeImprintLinkText) {
                    var koekjeImprintLinkText = "Impressum";
                }

                var koekjeHeadline = tryCatchAssign(plugin.settings.text.default.koekjeheadline, undefined);
                if(!koekjeHeadline) {
                    var koekjeHeadline = "Cookies & Dienste";
                }

                var koekjeSubheadline = tryCatchAssign(plugin.settings.text.default.koekjesubheadline, undefined);
                if(!koekjeSubheadline) {
                    var koekjeSubheadline = "Bitte wählen Sie, welche Dienste Sie automatisch zulassen möchten";
                }

                var koekjeButton = tryCatchAssign(plugin.settings.text.default.koekjebutton, undefined);
                if(!koekjeButton) {
                    var koekjeButton = "Alle akzeptieren";
                }

                var koekjeButtonSelection = tryCatchAssign(plugin.settings.text.default.koekjebuttonSelect, undefined);
                if(!koekjeButtonSelection) {
                    var koekjeButtonSelection = "Speichern";
                }

                var koekjeDetailChoice = tryCatchAssign(plugin.settings.text.default.koekjedetailSelect, undefined);
                if(!koekjeDetailChoice) {
                    var koekjeDetailChoice = "Details";
                }

                var koekjeCopy = tryCatchAssign(plugin.settings.text.default.koekjecopy, undefined);
                if(!koekjeCopy) {
                    var koekjeCopy = "Wir nutzen Cookies auf unserer Website. Einige von ihnen sind essenziell, während andere uns helfen, diese Website und Ihre Erfahrung zu verbessern.";
                }

                var koekjeAllowHeadline = tryCatchAssign(plugin.settings.text.default.koekjeallowHeadline, undefined);
                if(!koekjeAllowHeadline) {
                    var koekjeAllowHeadline = "Möchten Sie diese Inhalte immer erlauben?";
                }

                var koekjeAllowCopy = tryCatchAssign(plugin.settings.text.default.koekjeallowCopy, undefined);
                if(!koekjeAllowCopy) {
                    var koekjeAllowCopy = "Sie haben für diesen Inhaltstyp eine Ausnahme hinzugefügt. Möchten Sie diese Art Inhalt immer laden? Bei Bestätigung wird die Seite neu geladen.";
                }

                var koekjeAllowYes = tryCatchAssign(plugin.settings.text.default.koekjeallowYes, undefined);
                if(!koekjeAllowYes) {
                    var koekjeAllowYes = "Ja";
                }

                var koekjeAllowNo = tryCatchAssign(plugin.settings.text.default.koekjeallowNo, undefined);
                if(!koekjeAllowNo) {
                    var koekjeAllowNo = "Nein";
                }

                var koekjeAllowDoNotAsk = tryCatchAssign(plugin.settings.text.default.koekjeallowDoNotAsk, undefined);
                if(!koekjeAllowDoNotAsk) {
                    var koekjeAllowDoNotAsk = "Nicht mehr fragen";
                }

                var koekjeButtonText = tryCatchAssign(plugin.settings.text.default.koekjeallowButton, undefined);
                if(!koekjeButtonText) {
                    var koekjeButtonText = "Inhalte nachladen";
                }

                var koekjeButtonTextParagraph = tryCatchAssign(plugin.settings.text.default.koekjeallowButtonParagraph, undefined);
                if(!koekjeButtonTextParagraph) {
                    var koekjeButtonTextParagraph = "Erst wenn Sie hier klicken, werden Bilder und andere Daten von Drittanbietern nachgeladen. Ihre IP-Adresse wird dabei an externe Server (Facebook, Google, Instagram, Twitter, etc.) übertragen  und Cookies werden gesetzt. Über den Datenschutz dieser Anbieter können Sie sich auf den jeweiligen Seiten informieren.";
                }

                var koekjedescGoogleAnalytics = tryCatchAssign(plugin.settings.text.default.koekjedescGoogleAnalytics, undefined);
                if(!koekjedescGoogleAnalytics) {
                    var koekjedescGoogleAnalytics = "Google Analytics ist ein Trackingtool des US-Unternehmens Google, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                }

                var koekjedescYouTube = tryCatchAssign(plugin.settings.text.default.koekjedescYouTube, undefined);
                if(!koekjedescYouTube) {
                    var koekjedescYouTube = "YouTube ist eine Video-Plattform des US-Unternehmens Google, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                }

                var koekjedescSoundCloud = tryCatchAssign(plugin.settings.text.default.koekjedescSoundCloud, undefined);
                if(!koekjedescSoundCloud) {
                    var koekjedescSoundCloud = "SoundCloud ist ein Online-Musikdienst zum Austausch und zur Distribution von Audiodateien. Er dient als Kooperations- und Werbeplattform für Musiker";
                }

                var koekjedescFacebook = tryCatchAssign(plugin.settings.text.default.koekjedescFacebook, undefined);
                if(!koekjedescFacebook) {
                    var koekjedescFacebook = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                }

                var koekjedescFacebookMarketing = tryCatchAssign(plugin.settings.text.default.koekjedescFacebookMarketing, undefined);
                if(!koekjedescFacebookMarketing) {
                    var koekjedescFacebookMarketing = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden. Dies ist der FB-Pixel";
                }

                var koekjedescAdform = tryCatchAssign(plugin.settings.text.default.koekjedescAdform, undefined);
                if(!koekjedescAdform) {
                    var koekjedescAdform = "Adform ist ein dänisches Werbenetzwerk";
                }

                var koekjedescTwitter = tryCatchAssign(plugin.settings.text.default.koekjedescTwitter, undefined);
                if(!koekjedescTwitter) {
                    var koekjedescTwitter = "Twitter ist ein Mikrobloggingdienst für Kurznachrichten, das die Möglichkeit bietet, Profile, Tweets und die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                }

                var koekjedescVimeo = tryCatchAssign(plugin.settings.text.default.koekjedescVimeo, undefined);
                if(!koekjedescVimeo) {
                    var koekjedescVimeo = "Vimeo ist eine Video-Plattform, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                }

                var koekjedescSpotify = tryCatchAssign(plugin.settings.text.default.koekjedescSpotify, undefined);
                if(!koekjedescSpotify) {
                    var koekjedescSpotify = "Spotify ist ein Musik-Streamingdienst, der die Möglichkeit bietet, Profile, Playlisten und Songs auf externen Seiten einzubetten.";
                }

                var koekjedescGoogleMaps = tryCatchAssign(plugin.settings.text.default.koekjedescGoogleMaps, undefined);
                if(!koekjedescGoogleMaps) {
                    var koekjedescGoogleMaps = "Google Maps ist ein Kartendienst des US-Unternehmens Google, mit dem Routen, interaktive Karten und Kartenausschnitte auf Webseiten eingebettet werden können.";
                }

                var koekjedescInstagram = tryCatchAssign(plugin.settings.text.default.koekjedescInstagram, undefined);
                if(!koekjedescInstagram) {
                    var koekjedescInstagram = "Instagram ist ein soziales Netzwerk des US-Unternehens Facebook, das die Möglichkeit bietet, Bilder und Profile von Instagram auf anderen Seiten einzubetten.";
                }

                var koekjedescIssuu = tryCatchAssign(plugin.settings.text.default.koekjedescIssuu, undefined);
                if(!koekjedescIssuu) {
                    var koekjedescIssuu = "Issuu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                }

                var koekjedescYumpu = tryCatchAssign(plugin.settings.text.default.koekjedescYumpu, undefined);
                if(!koekjedescYumpu) {
                    var koekjedescYumpu = "Yumpu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                }

                var koekjedescMatomo = tryCatchAssign(plugin.settings.text.default.koekjedescMatomo, undefined);
                if(!koekjedescMatomo) {
                    var koekjedescMatomo = "Matomo (ehemals Piwik) ist ein Trackingtool, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                }

                var koekjedescUserlike = tryCatchAssign(plugin.settings.text.default.koekjedescUserlike, undefined);
                if(!koekjedescUserlike) {
                    var koekjedescUserlike = "Userlike ist ein Anbieter von Chat-Tools auf Webseiten. User können über ein eingebautes Chat-Fenster mit dem Support-Team einer Webseite in Kontakt treten oder in deren Abwesenheit eine Nachricht hinterlassen.";
                }

                var koekjeEssential = tryCatchAssign(plugin.settings.text.default.koekjeEssential, undefined);
                if(!koekjeEssential) {
                    var koekjeEssential = "Essentielle Cookies";
                }
                
                var koekjeStatistics = tryCatchAssign(plugin.settings.text.default.koekjeStatistics, undefined);
                if(!koekjeStatistics) {
                    var koekjeStatistics = "Statistiken";
                }

                var koekjeExtMedia = tryCatchAssign(plugin.settings.text.default.koekjeExtMedia, undefined);
                if(!koekjeExtMedia) {
                    var koekjeExtMedia = "Externe Medien";
                }

                var koekje3rdParty = tryCatchAssign(plugin.settings.text.default.koekje3rdParty, undefined);
                if(!koekje3rdParty) {
                    var koekje3rdParty = "Drittanbieter";
                }

                var cornerCookieText = tryCatchAssign(plugin.settings.text.default.koekjecornerCookieText, undefined);
                if(!cornerCookieText) {
                    var cornerCookieText = "Cookie Einstellungen anpassen";
                }
            }
        }
        else {
            
            try {
                if (koekjeLang.includes('en')) {
                    
                    var koekjePrivacyLinkText = 'Privacy Policy';
                    var koekjeImprintLinkText = 'Site Notice';
                    var koekjeHeadline = 'Cookies & Services';
                    var koekjeSubheadline = 'Please choose which services to allow automatically';
                    var koekjeButton = 'Accept all';
                    var koekjeButtonSelection = 'Accept selection';
                    var koekjeDetailChoice = 'Details';
                    var koekjeCopy = 'We are using Cookies on our website. Some of them are essential, other are helping us, improving this website and your experience.';
                    var koekjeAllowHeadline = 'Would you like to always allow that type of content?';
                    var koekjeAllowCopy = 'You added an exception for that type of content. Would you like to always allow that type of content? If you confirm, this page will be reloaded.';
                    var koekjeAllowYes = 'Yes';
                    var koekjeAllowNo = 'No';
                    var koekjeAllowDoNotAsk = 'Do not ask again';
                    var koekjeButtonText = 'click here to load additional content';
                    var koekjeButtonTextParagraph = 'Clicking here will result in loading additional images and other data from third-party providers. Your IP address will be transmitted to external servers (Facebook, Google, Instagram, Twitter, etc.) and cookies will be set. You can find out about the data protection of these providers on the respective pages.';
                    var koekjePrivacyLinkText = 'Privacy Policy';
                    var koekjeImprintLinkText = 'Site Notice';
                    var koekjedescGoogleAnalytics = 'Google Analytics is a tracking tool from the US company Google, working on the analysis of a websites data traffic. It analyzes origin, length of stay and browser settings of the site visitor.';
                    var koekjedescYouTube = 'YouTube is a video platform from the US company Google, on which videos can be hosted and embedded on other websites.';
                    var koekjedescSoundCloud = 'SoundCloud is an online audio distribution platform and music sharing website based in Berlin, Germany, that enables its users to upload, promote, and share audio, as well as a DSP enabling listeners to stream audio. ';
                    var koekjedescFacebook = 'Facebook is a social network, from which comments, profiles, likes and even the function of sharing can be implemented on a website.';
                    var koekjedescFacebookMarketing = 'descFacebookMarketing';
                    var koekjedescAdform = 'descAdform';
                    var koekjedescTwitter = 'Twitter is a microblogging platform for short messages, which can be embedded on other websites. Even embedding profiles and the function of sharing content can be implemented.';
                    var koekjedescVimeo = 'Vimeo is a video platform, on which videos can be hosted and be embedded on other websites.';
                    var koekjedescSpotify = 'Spotify is music streaming service, offering embedding profiles, playlists and songs on other websites.';
                    var koekjedescGoogleMaps = 'Google Maps is a map service from the US company Google. Routes, interactive maps and map excerpts can be embedded on other websites';
                    var koekjedescInstagram = 'Instagram is a social network from the US company Facebook, from which pictures, profiles can be embedded on other websites.';
                    var koekjedescIssuu = 'Issuu is a service for so called flip books - interactive, browzable PDF to be embedded on a website';
                    var koekjedescYumpu = 'Yumpu is a service for so called flip books - interactive, browzable PDF to be embedded on a website';
                    var koekjedescMatomo = 'Mamoto (former Piwik) is a tracking tool, working on the analysis of a websites data traffic. It analyzes origin, length of stay and browser settings of the site visitor.';
                    var koekjedescUserlike = 'Userlike is a service for chat tools on websites. Users could get in contact with the support team oder leaves a message via an embedded chat.';
                    var koekjeEssential = 'Essential';
                    var koekjeStatistics = 'Statistics';
                    var koekjeExtMedia = 'External Media';
                    var koekje3rdParty = 'Third Party';
                    var cornerCookieText = 'Adjust cookie settings';
                }

                else if (koekjeLang.includes('de')) {
                    
                    var koekjePrivacyLinkText = "Datenschutzerklärung";
                    var koekjeImprintLinkText = "Impressum";
                    var koekjeHeadline = "Cookies & Dienste";
                    var koekjeSubheadline = "Bitte wählen Sie, welche Dienste Sie automatisch zulassen möchten";
                    var koekjeButton = "Alle akzeptieren";
                    var koekjeButtonSelection = "Speichern";
                    var koekjeDetailChoice = "Details";
                    var koekjeCopy = "Wir nutzen Cookies auf unserer Website. Einige von ihnen sind essenziell, während andere uns helfen, diese Website und Ihre Erfahrung zu verbessern."
                    var koekjeAllowHeadline = "Möchten Sie diese Inhalte immer erlauben?";
                    var koekjeAllowCopy = "Sie haben für diesen Inhaltstyp eine Ausnahme hinzugefügt. Möchten Sie diese Art Inhalt immer laden? Bei Bestätigung wird die Seite neu geladen.";
                    var koekjeAllowYes = "Ja";
                    var koekjeAllowNo = "Nein";
                    var koekjeAllowDoNotAsk = "Nicht mehr fragen";
                    var koekjeButtonText = "Inhalte nachladen";
                    var koekjeButtonTextParagraph = "Erst wenn Sie hier klicken, werden Bilder und andere Daten von Drittanbietern nachgeladen. Ihre IP-Adresse wird dabei an externe Server (Facebook, Google, Instagram, Twitter, etc.) übertragen  und Cookies werden gesetzt. Über den Datenschutz dieser Anbieter können Sie sich auf den jeweiligen Seiten informieren.";
                    var koekjedescGoogleAnalytics = "Google Analytics ist ein Trackingtool des US-Unternehmens Google, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                    var koekjedescYouTube = "YouTube ist eine Video-Plattform des US-Unternehmens Google, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                    var koekjedescSoundCloud = "SoundCloud ist ein Online-Musikdienst zum Austausch und zur Distribution von Audiodateien. Er dient als Kooperations- und Werbeplattform für Musiker";
                    var koekjedescFacebook = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                    var koekjedescFacebookMarketing = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden. Dies ist der FB-Pixel";
                    var koekjedescAdform = "Adform ist ein dänisches Werbenetzwerk";
                    var koekjedescTwitter = "Twitter ist ein Mikrobloggingdienst für Kurznachrichten, das die Möglichkeit bietet, Profile, Tweets und die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                    var koekjedescVimeo = "Vimeo ist eine Video-Plattform, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                    var koekjedescSpotify = "Spotify ist ein Musik-Streamingdienst, der die Möglichkeit bietet, Profile, Playlisten und Songs auf externen Seiten einzubetten.";
                    var koekjedescGoogleMaps = "Google Maps ist ein Kartendienst des US-Unternehmens Google, mit dem Routen, interaktive Karten und Kartenausschnitte auf Webseiten eingebettet werden können.";
                    var koekjedescInstagram = "Instagram ist ein soziales Netzwerk des US-Unternehens Facebook, das die Möglichkeit bietet, Bilder und Profile von Instagram auf anderen Seiten einzubetten.";
                    var koekjedescIssuu = "Issuu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                    var koekjedescYumpu = "Yumpu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                    var koekjedescMatomo = "Matomo (ehemals Piwik) ist ein Trackingtool, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                    var koekjedescUserlike = "Userlike ist ein Anbieter von Chat-Tools auf Webseiten. User können über ein eingebautes Chat-Fenster mit dem Support-Team einer Webseite in Kontakt treten oder in deren Abwesenheit eine Nachricht hinterlassen.";
                    var koekjeEssential = "Essentielle Cookies";
                    var koekjeStatistics = "Statistiken";
                    var koekjeExtMedia = "Externe Medien";
                    var koekje3rdParty = "Drittanbieter";
                    var cornerCookieText = "Cookie Einstellungen anpassen";

                } else {
                    var koekjePrivacyLinkText = "Datenschutzerklärung";
                    var koekjeImprintLinkText = "Impressum";
                    var koekjeHeadline = "Cookies & Dienste";
                    var koekjeSubheadline = "Bitte wählen Sie, welche Dienste Sie automatisch zulassen möchten";
                    var koekjeButton = "Alle akzeptieren";
                    var koekjeButtonSelection = "Speichern";
                    var koekjeDetailChoice = "Details";
                    var koekjeCopy = "Wir nutzen Cookies auf unserer Website. Einige von ihnen sind essenziell, während andere uns helfen, diese Website und Ihre Erfahrung zu verbessern."
                    var koekjeAllowHeadline = "Möchten Sie diese Inhalte immer erlauben?";
                    var koekjeAllowCopy = "Sie haben für diesen Inhaltstyp eine Ausnahme hinzugefügt. Möchten Sie diese Art Inhalt immer laden? Bei Bestätigung wird die Seite neu geladen.";
                    var koekjeAllowYes = "Ja";
                    var koekjeAllowNo = "Nein";
                    var koekjeAllowDoNotAsk = "Nicht mehr fragen";
                    var koekjeButtonText = "Inhalte nachladen";
                    var koekjeButtonTextParagraph = "Erst wenn Sie hier klicken, werden Bilder und andere Daten von Drittanbietern nachgeladen. Ihre IP-Adresse wird dabei an externe Server (Facebook, Google, Instagram, Twitter, etc.) übertragen  und Cookies werden gesetzt. Über den Datenschutz dieser Anbieter können Sie sich auf den jeweiligen Seiten informieren.";
                    var koekjedescGoogleAnalytics = "Google Analytics ist ein Trackingtool des US-Unternehmens Google, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                    var koekjedescYouTube = "YouTube ist eine Video-Plattform des US-Unternehmens Google, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                    var koekjedescSoundCloud = "SoundCloud ist ein Online-Musikdienst zum Austausch und zur Distribution von Audiodateien. Er dient als Kooperations- und Werbeplattform für Musiker";
                    var koekjedescFacebook = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                    var koekjedescFacebookMarketing = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden. Dies ist der FB-Pixel";
                    var koekjedescAdform = "Adform ist ein dänisches Werbenetzwerk";
                    var koekjedescTwitter = "Twitter ist ein Mikrobloggingdienst für Kurznachrichten, das die Möglichkeit bietet, Profile, Tweets und die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                    var koekjedescVimeo = "Vimeo ist eine Video-Plattform, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                    var koekjedescSpotify = "Spotify ist ein Musik-Streamingdienst, der die Möglichkeit bietet, Profile, Playlisten und Songs auf externen Seiten einzubetten.";
                    var koekjedescGoogleMaps = "Google Maps ist ein Kartendienst des US-Unternehmens Google, mit dem Routen, interaktive Karten und Kartenausschnitte auf Webseiten eingebettet werden können.";
                    var koekjedescInstagram = "Instagram ist ein soziales Netzwerk des US-Unternehens Facebook, das die Möglichkeit bietet, Bilder und Profile von Instagram auf anderen Seiten einzubetten.";
                    var koekjedescIssuu = "Issuu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                    var koekjedescYumpu = "Yumpu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                    var koekjedescMatomo = "Matomo (ehemals Piwik) ist ein Trackingtool, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                    var koekjedescUserlike = "Userlike ist ein Anbieter von Chat-Tools auf Webseiten. User können über ein eingebautes Chat-Fenster mit dem Support-Team einer Webseite in Kontakt treten oder in deren Abwesenheit eine Nachricht hinterlassen.";
                    var koekjeEssential = "Essentielle Cookies";
                    var koekjeStatistics = "Statistiken";
                    var koekjeExtMedia = "Externe Medien";
                    var koekje3rdParty = "Drittanbieter";
                    var cornerCookieText = "Cookie Einstellungen anpassen";
                }

            } catch (err) {
                
                var koekjeHeadline = "Cookies & Dienste"
                var koekjeSubheadline = "Bitte wählen Sie, welche Dienste Sie automatisch zulassen möchten"
                var koekjeButton = "Alle akzeptieren"
                var koekjeButtonSelection = "Auswahl speichern"
                var koekjeDetailChoice = "Details";
                var koekjeCopy = "Wir nutzen Cookies auf unserer Website. Einige von ihnen sind essenziell, während andere uns helfen, diese Website und Ihre Erfahrung zu verbessern."
                var koekjeLinktext = "weitere Informationen"
                var koekjeNextText = "weiter"
                var koekjeAllowHeadline = "Möchten Sie diese Inhalte immer erlauben?";
                var koekjeAllowCopy = "Sie haben für diesen Inhaltstyp eine Ausnahme hinzugefügt. Möchten Sie diese Art Inhalt immer laden? Bei Bestätigung wird die Seite neu geladen.";
                var koekjeAllowYes = "Ja";
                var koekjeAllowNo = "Nein";
                var koekjeAllowDoNotAsk = "Nicht mehr fragen";
                var koekjeButtonText = "Inhalte nachladen";
                var koekjeButtonTextParagraph = "Erst wenn Sie hier klicken, werden Bilder und andere Daten von Drittanbietern nachgeladen. Ihre IP-Adresse wird dabei an externe Server (Facebook, Google, Instagram, Twitter, etc.) übertragen  und Cookies werden gesetzt. Über den Datenschutz dieser Anbieter können Sie sich auf den jeweiligen Seiten informieren.";
                var koekjedescGoogleAnalytics = "Google Analytics ist ein Trackingtool des US-Unternehmens Google, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                var koekjedescYouTube = "YouTube ist eine Video-Plattform des US-Unternehmens Google, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                var koekjedescSoundCloud = "SoundCloud ist ein Online-Musikdienst zum Austausch und zur Distribution von Audiodateien. Er dient als Kooperations- und Werbeplattform für Musiker";
                var koekjedescFacebook = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                var koekjedescFacebookMarketing = "Facebook ist ein soziales Netzwerk, das die Möglichkeit bietet, Kommentare, Profile, Likes und auch die Funktion des Sharings von Inhalten auf externen Seiten einzubinden. Dies ist der FB-Pixel";
                var koekjedescAdform = "Adform ist ein dänisches Werbenetzwerk";
                var koekjedescTwitter = "Twitter ist ein Mikrobloggingdienst für Kurznachrichten, das die Möglichkeit bietet, Profile, Tweets und die Funktion des Sharings von Inhalten auf externen Seiten einzubinden.";
                var koekjedescVimeo = "Vimeo ist eine Video-Plattform, auf der Videos gehostet und auf anderen Seiten eingebunden werden können.";
                var koekjedescSpotify = "Spotify ist ein Musik-Streamingdienst, der die Möglichkeit bietet, Profile, Playlisten und Songs auf externen Seiten einzubetten.";
                var koekjedescGoogleMaps = "Google Maps ist ein Kartendienst des US-Unternehmens Google, mit dem Routen, interaktive Karten und Kartenausschnitte auf Webseiten eingebettet werden können.";
                var koekjedescInstagram = "Instagram ist ein soziales Netzwerk des US-Unternehens Facebook, das die Möglichkeit bietet, Bilder und Profile von Instagram auf anderen Seiten einzubetten.";
                var koekjedescIssuu = "Issuu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                var koekjedescYumpu = "Yumpu ist ein Anbieter von sogenannten Blätterkatalogen - interaktive, blätterbare PDF zum Einbetten auf anderen Webseiten.";
                var koekjedescMatomo = "Matomo (ehemals Piwik) ist ein Trackingtool, das der Datenverkehrsanalyse von Webseiten dient. Es analysiert u.a. Herkunft, Verweildauer sowie Browsereinstellungen des Besuchers.";
                var koekjedescUserlike = "Userlike ist ein Anbieter von Chat-Tools auf Webseiten. User können über ein eingebautes Chat-Fenster mit dem Support-Team einer Webseite in Kontakt treten oder in deren Abwesenheit eine Nachricht hinterlassen.";
                var koekjeEssential = "Essentielle Cookies";
                var koekjeStatistics = "Statistiken";
                var koekjeExtMedia = "Externe Medien";
                var koekje3rdParty = "Drittanbieter";
                var cornerCookieText = "Cookie Einstellungen anpassen";
            }
        }


        
            
        




        var koekjeCookie = Cookies.get('koekjeconfirm');
        var koekjeCookieAnalytics = Cookies.get('koekjeanalytics');
        var koekjeCookieYouTube = Cookies.get('koekjeyoutube');
        var koekjeCookieSoundCloud = Cookies.get('koekjesoundcloud');
        var koekjeCookieVimeo = Cookies.get('koekjevimeo');
        var koekjeCookieGoogleMaps = Cookies.get('koekjegooglemaps');
        var koekjeCookieTwitter = Cookies.get('koekjetwitter');
        var koekjeCookieFacebook = Cookies.get('koekjefacebook');
        var koekjeCookieFacebookMarketing = Cookies.get('koekjefacebookmarketing');
        var koekjeCookieAdform = Cookies.get('koekjeadform');
        var koekjeCookieSpotify = Cookies.get('koekjespotify');
        var koekjeCookieUserlike = Cookies.get('koekjeuserlike');
        var koekjeCookieInstagram = Cookies.get('koekjeinstagram');
        var koekjeCookieIssuu = Cookies.get('koekjeissuu');
        var koekjeCookieYumpu = Cookies.get('koekjeyumpu');
        var koekjeCookieNoTemp = Cookies.get('koekjenotemp');
        var koekjecustom1 = Cookies.get('koekjecustom1');
        var koekjecustom2 = Cookies.get('koekjecustom2');
        var koekjecustom3 = Cookies.get('koekjecustom3');
        var koekjecustom4 = Cookies.get('koekjecustom4');
        var koekjecustom5 = Cookies.get('koekjecustom5');
        var koekjecustom6 = Cookies.get('koekjecustom6');
        var koekjecustom7 = Cookies.get('koekjecustom7');
        var koekjecustom8 = Cookies.get('koekjecustom8');
        var koekjecustom9 = Cookies.get('koekjecustom9');
        var koekjecustom10 = Cookies.get('koekjecustom10');


        // Insert Analytics Code
        if (koekjeCookieAnalytics) {
            koekjeAddAnalytics();
        }

        // Define Widget
        koekjePosition = ["top", "bottom", "center"].includes(koekjePosition) ? koekjePosition : "top";
        koekjeMode = ["light", "dark"].includes(koekjeMode) ? koekjeMode : "light";
        koekjeLayout = ["small", "full"].includes(koekjeLayout) ? koekjeLayout : "small";
        koekjeHeadlineBool = typeof koekjeHeadlineBool === "boolean" ? koekjeHeadlineBool : true;

        koekjeBackgroundStyle = ["dots", "lines", "plain"].includes(koekjeBackgroundStyle) ? koekjeBackgroundStyle : "dots";

        koekjeWidgetLogo = koekjeLogo ? `<img src="${koekjeLogo}" id="koekjeLogo" />` : '';
        koekjePrivacyWidget = koekjeprivacyLinkURL ? `<a href="${koekjeprivacyLinkURL}">${koekjePrivacyLinkText}</a>` : '';
        koekjeImprintWidget = koekjeimprintLinkURL ? `<a href="${koekjeimprintLinkURL}">${koekjeImprintLinkText}</a>` : '';

        // Define Curtain
        if (curtain === false) {
            curtainValue = 0;
        } else {
            if (curtainOpacity) {
                curtainValue = curtainOpacity;
            } else {
                curtainValue = 0.5;
            }
        }
        if (showonImprint !== false) {
            showonImprint = true;
        }

        if (showonPrivacy !== false) {
            showonPrivacy = true;
        }

        // Define Corner Button
        if (cornerCookie === true) {
            var button = document.createElement('button');
            button.id = 'koekjeReload';
            button.className = 'koekjeCornerButton';
            button.setAttribute('aria-label', cornerCookieText);
            button.setAttribute('koekje_id', koekje_id);
            button.innerHTML = `<span>${cornerCookieText}</span><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path d="M510.52 255.82c-69.97-.85-126.47-57.69-126.47-127.86-70.17 0-127-56.49-127.86-126.45-27.26-4.14-55.13.3-79.72 12.82l-69.13 35.22a132.221 132.221 0 0 0-57.79 57.81l-35.1 68.88a132.645 132.645 0 0 0-12.82 80.95l12.08 76.27a132.521 132.521 0 0 0 37.16 72.96l54.77 54.76a132.036 132.036 0 0 0 72.71 37.06l76.71 12.15c27.51 4.36 55.7-.11 80.53-12.76l69.13-35.21a132.273 132.273 0 0 0 57.79-57.81l35.1-68.88c12.56-24.64 17.01-52.58 12.91-79.91zM176 368c-17.67 0-32-14.33-32-32s14.33-32 32-32 32 14.33 32 32-14.33 32-32 32zm32-160c-17.67 0-32-14.33-32-32s14.33-32 32-32 32 14.33 32 32-14.33 32-32 32zm160 128c-17.67 0-32-14.33-32-32s14.33-32 32-32 32 14.33 32 32-14.33 32-32 32z"></path></svg>`;

            var body = document.querySelector('body');
            body.appendChild(button);
        }

        // Build Widget

        if (koekjeCookie != "true") {

            
            const sectionClass = `${koekjeBackgroundStyle} ${koekjeMode} ${koekjePointer}`;
            const widgetClass = `${koekjePosition} ${koekjeMode} ${koekjeLayout} ${koekjeShadow}`;

            const switchInput = `<input type="checkbox" name="koekjeEssential" id="koekjeEssential" checked="checked" readonly="readonly" aria-labelledby="labelKoekjeEssential" />`;
            const switchSpan = `<span class="slider round"></span>`;
            const switchLabel = `<label class="switch">${switchInput}${switchSpan}</label>`;

            const essentialCheckbox = `<div>${switchLabel}<span id="labelKoekjeEssential">${koekjeEssential}</span></div>`;
            const extMediaCheckbox = `<div><label class="switch"><input type="checkbox" name="koekjeExtMedia" id="koekjeExtMedia" aria-labelledby="labelkoekjeExtMedia" />${switchSpan}</label><span id="labelkoekjeExtMedia">${koekjeExtMedia}</span></div>`;
            const statisticsCheckbox = `<div><label class="switch"><input type="checkbox" name="koekjeStatistics" id="koekjeStatistics" aria-labelledby="labelkoekjeStatistics" />${switchSpan}</label><span id="labelkoekjeStatistics">${koekjeStatistics}</span></div>`;
            const thirdPartyCheckbox = `<div><label for="koekje3rdParty" class="switch"><input type="checkbox" name="koekje3rdParty" aria-labelledby="labelkoekje3rdParty" id="koekje3rdParty" />${switchSpan}</label><span id="labelkoekje3rdParty">${koekje3rdParty}</span></div>`;

            const servicesSection = `<section><div id="koekjeServices"><h2 class="koekjeHeadline">${koekjeSubheadline}</h2></div></section>`;
            const buttonsSection = `<section><div id="koekjeButtons"><button id="koekjeConfirm">${koekjeButtonSelection}</button><button id="koekjeConfirmAll">${koekjeButton}</button></div></section>`;

            const versionCredits = `<small class="koekjeVersion"><div class="koekjeCredits">&copy; <a href="https://koekje-js.de" target="_blank">KOEKJE</a> ${koekjeVersion} | ${koekjeOrigin} | ${koekjeImprintWidget} | ${koekjePrivacyWidget}</div></small>`;

            const koekjeWidgetSource = `<section id="koekjeBackground" class="${sectionClass}" style="opacity:${curtainValue}"></section>
            <section id="koekjeWidget" class="${widgetClass}">
            <article>${koekjeWidgetLogo}
                <h1 class="koekjeHeadline">${koekjeHeadline}</h1>
                <p>${koekjeCopy}</p>
                <section id="koekjeCategories">
                ${essentialCheckbox}
                ${extMediaCheckbox}
                ${statisticsCheckbox}
                ${thirdPartyCheckbox}
                </section>
                ${servicesSection}
                ${buttonsSection}
                <span id="koekjeDetailChoice">${koekjeDetailChoice}</span>
                ${versionCredits}
            </article>
            </section>`;

            var curPagePath = window.location.pathname;
            if(koekjeprivacyLinkURL && koekjeimprintLinkURL) {
                
                if (curPagePath.includes(koekjeprivacyLinkURL) || curPagePath.includes(koekjeimprintLinkURL)) {
                    
                    if (curPagePath.includes(koekjeimprintLinkURL) && showonImprint) {
                        
                        document.body.insertAdjacentHTML('beforeend', koekjeWidgetSource);
                    }
                    if (curPagePath.includes(koekjeprivacyLinkURL) && showonPrivacy) {
                        
                        document.body.insertAdjacentHTML('beforeend', koekjeWidgetSource);
                    }
               } else {
                document.body.insertAdjacentHTML('beforeend', koekjeWidgetSource);
               }
            } else {
                
                document.body.insertAdjacentHTML('beforeend', koekjeWidgetSource);
            }
        

            if (koekjeFonts) {
                var koekjeWidgetElement = document.querySelector("#koekjeWidget");
                koekjeWidgetElement.classList.add("customfont");
                koekjeBtnFont = "customfont";
            }
            

            

            // Add Services to Widget

            if (GoogleAnalytics) {
                var prop = (koekjeGoogleAnalyticsEssential) ? "checked disabled" : "";
                var propdesc = (koekjeGoogleAnalyticsEssential) ? " (essentiell)" : "";
                var propclass = (koekjeGoogleAnalyticsEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeAnalytics" class="switch"><input type="checkbox" name="koekjeAnalytics" id="koekjeAnalytics"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Google Analytics ${propdesc}<p>${koekjedescGoogleAnalytics}</p></div>`);
            }
            if (YouTube) {
                var prop = (koekjeYouTubeEssential) ? "checked disabled" : "";
                var propdesc = (koekjeYouTubeEssential) ? " (essentiell)" : "";
                var propclass = (koekjeYouTubeEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeYouTube" class="switch"><input type="checkbox" name="koekjeYouTube" id="koekjeYouTube"  class="${propclass}" ${prop}/><span class="slider round"></span></label>YouTube ${propdesc}<p>${koekjedescYouTube}</p></div>`);
            }
            if (SoundCloud) {
                var prop = (koekjeSoundCloudEssential) ? "checked disabled" : "";
                var propdesc = (koekjeSoundCloudEssential) ? " (essentiell)" : "";
                var propclass = (koekjeSoundCloudEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeSoundCloud" class="switch"><input type="checkbox" name="koekjeSoundCloud" id="koekjeSoundCloud"  class="${propclass}" ${prop}/><span class="slider round"></span></label>SoundCloud ${propdesc}<p>${koekjedescSoundCloud}</p></div>`);
            }
            if (Facebook) {
                var prop = (koekjeFacebookEssential) ? "checked disabled" : "";
                var propdesc = (koekjeFacebookEssential) ? " (essentiell)" : "";
                var propclass = (koekjeFacebookEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeFacebook" class="switch"><input type="checkbox" name="koekjeFacebook" id="koekjeFacebook"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Facebook ${propdesc}<p>${koekjedescFacebook}</p></div>`);
            }

            if (FacebookMarketing) {
                var prop = (koekjeFacebookMarketingEssential) ? "checked disabled" : "";
                var propdesc = (koekjeFacebookMarketingEssential) ? " (essentiell)" : "";
                var propclass = (koekjeFacebookMarketingEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeFacebookMarketing" class="switch"><input type="checkbox" name="koekjeFacebookMarketing" id="koekjeFacebookMarketing"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Facebook Marketing ${propdesc}<p>${koekjedescFacebookMarketing}</p></div>`);
            }

            if (Adform) {
                var prop = (koekjeAdformEssential) ? "checked disabled" : "";
                var propdesc = (koekjeAdformEssential) ? " (essentiell)" : "";
                var propclass = (koekjeAdformEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeAdform" class="switch"><input type="checkbox" name="koekjeAdform" id="koekjeAdform"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Adform ${propdesc}<p>${koekjedescAdform}</p></div>`);
            }

            if (Twitter) {
                var prop = (koekjeTwitterEssential) ? "checked disabled" : "";
                var propdesc = (koekjeTwitterEssential) ? " (essentiell)" : "";
                var propclass = (koekjeTwitterEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeTwitter" class="switch"><input type="checkbox" name="koekjeTwitter" id="koekjeTwitter"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Twitter ${propdesc}<p>${koekjedescTwitter}</p></div>`);
            }
            if (Vimeo) {
                var prop = (koekjeVimeoEssential) ? "checked disabled" : "";
                var propdesc = (koekjeVimeoEssential) ? " (essentiell)" : "";
                var propclass = (koekjeVimeoEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeVimeo" class="switch"><input type="checkbox" name="koekjeVimeo" id="koekjeVimeo" class="${propclass}" ${prop}/><span class="slider round"></span></label>Vimeo ${propdesc}<p>${koekjedescVimeo}</p></div>`);
            }
            if (Matomo) {
                var prop = (koekjeMatomoEssential) ? "checked disabled" : "";
                var propdesc = (koekjeMatomoEssential) ? " (essentiell)" : "";
                var propclass = (koekjeMatomoEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeMatomo" class="switch"><input type="checkbox" name="koekjeMatomo" id="koekjeMatomo"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Matomo ${propdesc}<p>${koekjedescMatomo}</p></div>`);
            }
            if (Spotify) {
                var prop = (koekjeSpotifyEssential) ? "checked disabled" : "";
                var propdesc = (koekjeSpotifyEssential) ? " (essentiell)" : "";
                var propclass = (koekjeSpotifyEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeSpotify" class="switch"><input type="checkbox" name="koekjeSpotify" id="koekjeSpotify"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Spotify ${propdesc}<p>${koekjedescSpotify}</p></div>`);
            }
            if (GoogleMaps) {
                var prop = (koekjeGoogleMapsEssential) ? "checked disabled" : "";
                var propdesc = (koekjeGoogleMapsEssential) ? " (essentiell)" : "";
                var propclass = (koekjeGoogleMapsEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeGoogleMaps" class="switch"><input type="checkbox" name="koekjeGoogleMaps" id="koekjeGoogleMaps"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Google Maps ${propdesc}<p>${koekjedescGoogleMaps}</p></div>`);
            }
            if (Userlike) {
                var prop = (koekjeUserlikeEssential) ? "checked disabled" : "";
                var propdesc = (koekjeUserlikeEssential) ? " (essentiell)" : "";
                var propclass = (koekjeUserlikeEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeUserlike" class="switch"><input type="checkbox" name="koekjeUserlike" id="koekjeUserlike"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Userlike ${propdesc}<p>${koekjedescUserlike}</p></div>`);
            }
            if (Instagram) {
                var prop = (koekjeInstagramEssential) ? "checked disabled" : "";
                var propdesc = (koekjeInstagramEssential) ? " (essentiell)" : "";
                var propclass = (koekjeInstagramEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeInstagram" class="switch"><input type="checkbox" name="koekjeInstagram" id="koekjeInstagram"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Instagram ${propdesc}<p>${koekjedescInstagram}</p></div>`);
            }
            if (Issuu) {
                var prop = (koekjeIssuuEssential) ? "checked disabled" : "";
                var propdesc = (koekjeIssuuEssential) ? " (essentiell)" : "";
                var propclass = (koekjeIssuuEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeIssuu" class="switch"><input type="checkbox" name="koekjeIssuu" id="koekjeIssuu"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Issuu ${propdesc}<p>${koekjedescIssuu}</p></div>`);
            }
            if (Yumpu) {
                var prop = (koekjeYumpuEssential) ? "checked disabled" : "";
                var propdesc = (koekjeYumpuEssential) ? " (essentiell)" : "";
                var propclass = (koekjeYumpuEssential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeYumpu" class="switch"><input type="checkbox" name="koekjeYumpu" id="koekjeYumpu"  class="${propclass}" ${prop}/><span class="slider round"></span></label>Yumpu ${propdesc}<p>${koekjedescYumpu}</p></div>`);
            }

            if (custom1) {
                var prop = (custom1essential) ? "checked disabled" : "";
                var propdesc = (custom1essential) ? " (essentiell)" : "";
                var propclass = (custom1essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom1" class="switch"><input type="checkbox" name="koekjeCustom1" id="koekjeCustom1"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom1title} ${propdesc}<p>${custom1description}</p></div>`);
            }

            if (custom2) {
                var prop = (custom2essential) ? "checked disabled" : "";
                var propdesc = (custom2essential) ? " (essentiell)" : "";
                var propclass = (custom2essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom2" class="switch"><input type="checkbox" name="koekjeCustom2" id="koekjeCustom2"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom2title} ${propdesc}<p>${custom2description}</p></div>`);
            }

            if (custom3) {
                var prop = (custom3essential) ? "checked disabled" : "";
                var propdesc = (custom3essential) ? " (essentiell)" : "";
                var propclass = (custom3essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom3" class="switch"><input type="checkbox" name="koekjeCustom3" id="koekjeCustom3"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom3title} ${propdesc}<p>${custom3description}</p></div>`);
            }

            if (custom4) {
                var prop = (custom4essential) ? "checked disabled" : "";
                var propdesc = (custom4essential) ? " (essentiell)" : "";
                var propclass = (custom4essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom4" class="switch"><input type="checkbox" name="koekjeCustom4" id="koekjeCustom4"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom4title} ${propdesc}<p>${custom4description}</p></div>`);
            }

            if (custom5) {
                var prop = (custom5essential) ? "checked disabled" : "";
                var propdesc = (custom5essential) ? " (essentiell)" : "";
                var propclass = (custom5essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom5" class="switch"><input type="checkbox" name="koekjeCustom5" id="koekjeCustom5"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom5title} ${propdesc}<p>${custom5description}</p></div>`);
            }

            if (custom6) {
                var prop = (custom6essential) ? "checked disabled" : "";
                var propdesc = (custom6essential) ? " (essentiell)" : "";
                var propclass = (custom6essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom6" class="switch"><input type="checkbox" name="koekjeCustom6" id="koekjeCustom6"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom6title} ${propdesc}<p>${custom6description}</p></div>`);
            }

            if (custom7) {
                var prop = (custom7essential) ? "checked disabled" : "";
                var propdesc = (custom7essential) ? " (essentiell)" : "";
                var propclass = (custom7essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom7" class="switch"><input type="checkbox" name="koekjeCustom7" id="koekjeCustom7"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom7title} ${propdesc}<p>${custom7description}</p></div>`);
            }

            if (custom8) {
                var prop = (custom8essential) ? "checked disabled" : "";
                var propdesc = (custom8essential) ? " (essentiell)" : "";
                var propclass = (custom8essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom8" class="switch"><input type="checkbox" name="koekjeCustom8" id="koekjeCustom8"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom8title} ${propdesc}<p>${custom8description}</p></div>`);
            }

            if (custom9) {
                var prop = (custom9essential) ? "checked disabled" : "";
                var propdesc = (custom9essential) ? " (essentiell)" : "";
                var propclass = (custom9essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom9" class="switch"><input type="checkbox" name="koekjeCustom9" id="koekjeCustom9"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom9title} ${propdesc}<p>${custom9description}</p></div>`);
            }

            if (custom10) {
                var prop = (custom10essential) ? "checked disabled" : "";
                var propdesc = (custom10essential) ? " (essentiell)" : "";
                var propclass = (custom10essential) ? "KoekjeEssential" : "";
                $("#koekjeServices")
                    .append(`<div><label for="koekjeCustom10" class="switch"><input type="checkbox" name="koekjeCustom10" id="koekjeCustom10"  class="${propclass}" ${prop}/><span class="slider round"></span></label>${custom10title} ${propdesc}<p>${custom10description}</p></div>`);
            }
        }

        // Customize Widget
        if (koekjeSelectors === 0) {
            var headline = document.querySelector('h2.koekjeHeadline');
            var services = document.getElementById('koekjeServices');
            var confirmAll = document.getElementById('koekjeConfirmAll');

            if (headline) {
                headline.remove();
            }

            if (services) {
                services.remove();
            }

            if (confirmAll) {
                confirmAll.innerHTML = "Okay";
            }
            
            $("#koekjeDetailChoice").remove()
        }

        // Placeholder
        if (koekjePlaceholder === true) {
            var elements = document.querySelectorAll('.koekje');
            elements.forEach(function (el) {
                el.classList.add('koekjeOff');
            });
        } else {
            var elements = document.querySelectorAll('.koekje');
            elements.forEach(function (el) {
                el.classList.add('koekjeOff10');
            });
        }

        var elements = document.querySelectorAll('.koekje');
        elements.forEach(function (el, index) {
            el.setAttribute('koekjeid', 'koekjetarget' + index);
        });


        // Apply Styles
        if (koekjeBackgroundColor) {
            var validBackground = /^#([0-9A-F]{3}){1,2}$/i.test(koekjeBackgroundColor);
            if (validBackground) {
                var article = document.querySelector('#koekjeWidget > article');
                if (article) {
                    article.style.background = koekjeBackgroundColor;
                }
            }
        }

        if (koekjeTextColor) {
            var validText = /^#([0-9A-F]{3}){1,2}$/i.test(koekjeTextColor);
            if (validText) {
                var elements = document.querySelectorAll('#koekjeWidget *');
                if (elements) {
                    elements.forEach(function (element) {
                        element.style.color = koekjeTextColor;
                    });
                }
            }
        }

        if (cornerCookieColor) {
            var validColor = /^#([0-9A-F]{3}){1,2}$/i.test(cornerCookieColor);
            if (validColor) {
                var svgElements = document.querySelectorAll('.koekjeCornerButton svg');
                svgElements.forEach(function (svgElement) {
                    svgElement.style.fill = cornerCookieColor;
                });
            }
        }

        if (koekjeButtonColor) {
            var validColor = /^#([0-9A-F]{3}){1,2}$/i.test(koekjeButtonColor);
            if (validColor) {
                var buttonElements = document.querySelectorAll('#koekjeWidget button');
                if (buttonElements) {
                    buttonElements.forEach(function (buttonElement) {
                        buttonElement.style.background = koekjeButtonColor;
                        var brightness = lightOrDark(koekjeButtonColor);
                        buttonElement.style.color = (brightness === 'dark') ? '#fff' : '#000';
                    });
                }
            }
        }

        if (koekjeSliderColor) {
            var validColor = /^#([0-9A-F]{3}){1,2}$/i.test(koekjeSliderColor);
            if (validColor) {
                var styleElement = document.createElement('style');
                styleElement.setAttribute('type', 'text/css');
                styleElement.textContent = `#koekjeWidget input:checked + .slider, #koekjeWidget input[readonly="readonly"] + .slider { background-color: ${koekjeSliderColor} !important;} #koekjeWidget #koekjeDetailChoice:after {border-top: 10px solid ${koekjeSliderColor}; }`;
                document.head.appendChild(styleElement);
            }
        }

        // Google Analytics
        function koekjeAddAnalytics() {
            var headElement = document.querySelector('head');
            var bodyElement = document.querySelector('body');

            var gaScript = document.createElement('script');
            gaScript.setAttribute('type', 'text/javascript');
            gaScript.textContent = `var gaProperty = "${googleID}"; var disableStr = "ga-disable-" + gaProperty; if (document.cookie.indexOf(disableStr + "=true") > -1) { window[disableStr] = true; } function gaOptout() { document.cookie = disableStr + "=true; expires=Thu, 31 Dec 2099 23:59:59 UTC; path=/"; window[disableStr] = true; alert("Das Tracking durch Google Analytics wurde in Ihrem Browser für diese Website deaktiviert."); }`;

            var gtagScript = document.createElement('script');
            gtagScript.setAttribute('type', 'text/javascript');
            gtagScript.setAttribute('async', 'async');
            gtagScript.setAttribute('src', `https://www.googletagmanager.com/gtag/js?id=${googleID}`);

            var gtagConfigScript = document.createElement('script');
            gtagConfigScript.setAttribute('type', 'text/javascript');
            gtagConfigScript.textContent = `window.dataLayer = window.dataLayer || []; function gtag(){dataLayer.push(arguments);} gtag("js", new Date()); gtag("config", "${googleID}");`;

            if (GoogleLoadOnTop === true) {
                headElement.prepend(gaScript);
                headElement.prepend(gtagScript);

                if (googletagmanagerID) {
                    var gtmScript = document.createElement('script');
                    gtmScript.setAttribute('type', 'text/javascript');
                    gtmScript.textContent = `(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({"gtm.start":new Date().getTime(),event:"gtm.js"});var f=d.getElementsByTagName(s)[0],j=d.createElement(s),dl=l!="dataLayer"?"&l="+l:"";j.async=true;j.src="https://www.googletagmanager.com/gtm.js?id="+i+dl;f.parentNode.insertBefore(j,f);})(window,document,"script","dataLayer","${googletagmanagerID}");`;

                    headElement.prepend(gtmScript);
                }
            } else {
                bodyElement.appendChild(gaScript);
                bodyElement.appendChild(gtagScript);
                bodyElement.appendChild(gtagConfigScript);

                if (googletagmanagerID) {
                    var gtmScript = document.createElement('script');
                    gtmScript.setAttribute('type', 'text/javascript');
                    gtmScript.textContent = `(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({"gtm.start":new Date().getTime(),event:"gtm.js"});var f=d.getElementsByTagName(s)[0],j=d.createElement(s),dl=l!="dataLayer"?"&l="+l:"";j.async=true;j.src="https://www.googletagmanager.com/gtm.js?id="+i+dl;f.parentNode.insertBefore(j,f);})(window,document,"script","dataLayer","${googletagmanagerID}");`;

                    bodyElement.appendChild(gtmScript);
                }
            }
        }

        // Soundcloud
        if (koekjeCookieSoundCloud !== "true") {
            document.querySelectorAll('*[koekjetype="soundcloud"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (SoundCloud)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                el.parentNode.insertBefore(button, el);
                el.parentNode.insertBefore(smallInfo, el);
                button.parentNode.insertBefore(el, button);
            });
        }

        if (koekjeCookieSoundCloud === "true") {
            document.querySelectorAll('*[koekjetype="soundcloud"]').forEach(function (el) {
                var koekjeURL = el.getAttribute("data-src");
                el.removeAttribute('data-src');
                el.setAttribute('src', koekjeURL);
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');
            });
        }

        // YouTube

        if (koekjeCookieYouTube !== "true") {
            document.querySelectorAll('*[koekjetype="youtube"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (YouTube)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                // el.parentNode.insertBefore(button, el);
                // el.parentNode.insertBefore(smallInfo, el);
                // button.parentNode.insertBefore(el, button);

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }


        // Userlike
        if (koekjeCookieUserlike === "true") {
            document.querySelectorAll('*[koekjetype="userlike"]').forEach(function (el) {
                var koekjeURL = el.getAttribute("data-src");
                el.removeAttribute('data-src');
                el.setAttribute('src', koekjeURL);
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');
            });
        }

        // YouTube
        if (koekjeCookieYouTube === "true") {
            document.querySelectorAll('*[koekjetype="youtube"]').forEach(function (el) {
                var koekjeURL = el.getAttribute("data-src");
                el.removeAttribute('data-src');
                el.setAttribute('src', koekjeURL);
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');
            });
        }

        // Vimeo
        if (koekjeCookieVimeo !== "true") {
            document.querySelectorAll('*[koekjetype="vimeo"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Vimeo)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieVimeo === "true") {
            document.querySelectorAll('*[koekjetype="vimeo"]').forEach(function (el) {
                var koekjeURL = el.getAttribute("data-src");
                el.removeAttribute('data-src');
                el.setAttribute('src', koekjeURL);
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');
            });
        }



        // Google Maps
        if (koekjeCookieGoogleMaps !== "true") {
            document.querySelectorAll('*[koekjetype="googlemaps"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Google Maps)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieGoogleMaps === "true") {
            document.querySelectorAll('*[koekjetype="googlemaps"]').forEach(function (el) {
                if (el.tagName === "IFRAME") {
                    var koekjeURL = el.getAttribute("data-src");
                    el.removeAttribute('data-src');
                    el.setAttribute('src', koekjeURL);
                }
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');
            });

            if (mapsKey && mapsFunction) {
                var mapsApiCall = 'https://maps.google.com/maps/api/js?key=' + mapsKey + '&libraries=places';
                var script = document.createElement('script');
                script.src = mapsApiCall;
                script.onload = function () {
                    var fn = window[mapsFunction];
                    if (typeof fn === 'function') {
                        fn();
                    }
                };
                document.head.appendChild(script);
            }
        }


        // Twitter
        if (koekjeCookieTwitter !== "true") {
            document.querySelectorAll('*[koekjetype="twitter"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Twitter)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieTwitter === "true") {
            document.querySelectorAll('*[koekjetype="twitter"]').forEach(function (el) {
                var script = document.createElement('script');
                script.setAttribute('type', 'text/javascript');
                script.setAttribute('async', '');
                script.setAttribute('charset', 'utf-8');
                script.setAttribute('src', 'https://platform.twitter.com/widgets.js');
                el.parentNode.insertBefore(script, el.nextSibling);
            });
        }


        if (koekjecustom1 === "true") {
            if (custom1type === "script") {
                $("body").append(custom1script);
            }
        }
        if (koekjecustom2 === "true") {
            if (custom2type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom3 === "true") {
            if (custom3type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom4 === "true") {
            if (custom4type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom5 === "true") {
            if (custom5type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom6 === "true") {
            if (custom6type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom7 === "true") {
            if (custom7type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom8 === "true") {
            if (custom8type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom9 === "true") {
            if (custom9type === "script") {
                $("body").append(custom2script);
            }
        }
        if (koekjecustom10 === "true") {
            if (custom10type === "script") {
                $("body").append(custom2script);
            }
        }
        

        // Spotify
        if (koekjeCookieSpotify !== "true") {
            document.querySelectorAll('*[koekjetype="spotify"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Spotify)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieSpotify === "true") {
            document.querySelectorAll('*[koekjetype="spotify"]').forEach(function (el) {
                var koekjeURL = el.getAttribute("data-src");
                el.removeAttribute('data-src');
                el.setAttribute('src', koekjeURL);
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');
            });
        }

        // Facebook
        if (koekjeCookieFacebook !== "true") {
            document.querySelectorAll('*[koekjetype="facebook"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Facebook)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieFacebook === "true") {
            document.querySelectorAll('*[koekjetype="facebook"]').forEach(function (el) {
                var koekjeURL = el.getAttribute("data-src");
                el.removeAttribute('data-src');
                el.setAttribute('src', koekjeURL);
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');


            });
        }

        // Facebook Marketing
        if (koekjeCookieFacebookMarketing === "true") {
            var script = document.createElement('script');
            script.setAttribute('type', 'text/javascript');
            script.text = `(function () {var _fbq = window._fbq || (window._fbq = []);if (!_fbq.loaded) {var fbds = document.createElement("script");fbds.async = true;fbds.src = "https://connect.facebook.net/en_US/fbds.js";var s = document.getElementsByTagName("script")[0];s.parentNode.insertBefore(fbds, s);_fbq.loaded = true;}})();window._fbq = window._fbq || [];window._fbq.push(["track", "${facebookID}", { "value": "0.00", "currency": "${facebookCurrency}" }]); `;
            document.body.appendChild(script);
        }

        // Adform
        if (koekjeCookieAdform === "true") {
            var script = document.createElement('script');
            script.setAttribute('type', 'text/javascript');
            script.text = `window._adftrack = {pm: ${AdformPM},divider: encodeURIComponent("|"),pagename: encodeURIComponent("${AdformPageName}")};(function () { var s = document.createElement("script");s.type = "text/javascript";s.async = true;s.src = "https://track.adform.net/serving/scripts/trackpoint/async/"; var x = document.getElementsByTagName("script")[0];x.parentNode.insertBefore(s, x); })();`;
            document.body.appendChild(script);
        }

        // Instagram
        if (koekjeCookieInstagram !== "true") {
            document.querySelectorAll('*[koekjetype="instagram"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Instagram)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieInstagram === "true") {
            document.querySelectorAll('*[koekjetype="instagram"]').forEach(function (el) {
                document.querySelectorAll('.instagram-media').forEach(function (mediaEl) {
                    mediaEl.classList.remove('koekjeOff');
                    mediaEl.classList.remove('koekjeOff10');
                });

                var script = document.createElement('script');
                script.setAttribute('type', 'text/javascript');
                script.setAttribute('async', '');
                script.setAttribute('charset', 'utf-8');
                script.setAttribute('src', 'https://www.instagram.com/embed.js');
                el.parentNode.insertBefore(script, el.nextSibling);
            });
        }

        // Issuu
        if (koekjeCookieIssuu !== "true") {
            document.querySelectorAll('*[koekjetype="issuu"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Issuu)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieIssuu === "true") {
            document.querySelectorAll('*[koekjetype="issuu"]').forEach(function (el) {
                document.querySelectorAll('.issuuembed').forEach(function (embedEl) {
                    embedEl.classList.remove('koekjeOff');
                    embedEl.classList.remove('koekjeOff10');
                });

                var script = document.createElement('script');
                script.setAttribute('type', 'text/javascript');
                script.setAttribute('async', '');
                script.setAttribute('charset', 'utf-8');
                script.setAttribute('src', 'https://e.issuu.com/embed.js');
                el.parentNode.insertBefore(script, el.nextSibling);
            });
        }

        // Yumpu
        if (koekjeCookieYumpu !== "true") {
            document.querySelectorAll('*[koekjetype="yumpu"]').forEach(function (el) {
                var container = document.createElement('div');
                container.classList.add('koekjeContainer');
                el.parentNode.insertBefore(container, el);

                var button = document.createElement('button');
                button.classList.add('koekje', 'koekje' + el.getAttribute('koekjetype'), koekjeMode);
                button.setAttribute('koekjebtn', el.getAttribute('koekjeid'));
                button.innerHTML = koekjeButtonText + ' (Yumpu)';
                var smallInfo = document.createElement('small');
                smallInfo.classList.add('koekjesmallinfo');
                smallInfo.innerHTML = koekjeButtonTextParagraph;

                container.appendChild(button);
                container.appendChild(smallInfo);
                container.appendChild(el);
            });
        }

        if (koekjeCookieYumpu === "true") {
            document.querySelectorAll('*[koekjetype="yumpu"]').forEach(function (el) {
                var koekjeURL = el.getAttribute('data-src');
                el.removeAttribute('data-src');
                el.setAttribute('src', koekjeURL);
                el.classList.remove('koekjeOff');
                el.classList.remove('koekjeOff10');
            });
        }

        // Buttons
        $("body")
            .on('click', 'button.koekje', function (event) {
                event.preventDefault();
                $(this).next(".koekjeContainer small")
                    .remove();
                koekjeURL = $("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .attr("data-src");
                koekjeType = $("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .attr('koekjetype');
                if ($("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .prop("tagName") == "IFRAME") {
                    $("*[koekjeid='" + $(this)
                        .attr('koekjebtn') + "']")
                        .removeAttr('data-src');
                    $("*[koekjeid='" + $(this)
                        .attr('koekjebtn') + "']")
                        .attr('src', koekjeURL);
                    $("*[koekjeid='" + $(this)
                        .attr('koekjebtn') + "'].koekjeOff")
                        .removeClass('koekjeOff')
                    $("*[koekjeid='" + $(this)
                        .attr('koekjebtn') + "'].koekjeOff10")
                        .removeClass('koekjeOff10')
                }
                if ($("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .prop("tagName") != "IFRAME" && $("*[koekjeid='" + $(this)
                        .attr('koekjebtn') + "']")
                        .attr('koekjetype') == "googlemaps") {
                    var mapsApiCall = `https://maps.google.com/maps/api/js?key=${mapsKey}&libraries=places`;
                    jQuery.getScript(mapsApiCall)
                        .done(function () {
                            var fn = window[mapsFunction];
                            fn();
                        })
                    $("*[koekjeid='" + $(this)
                        .attr('koekjebtn') + "'].koekjeOff")
                        .removeClass('koekjeOff')
                    $("*[koekjeid='" + $(this)
                        .attr('koekjebtn') + "'].koekjeOff10")
                        .removeClass('koekjeOff10')
                }
                if ($("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .attr('koekjetype') == "twitter") {
                    $('<script>')
                        .attr('type', 'text/javascript')
                        .attr('async', '')
                        .attr('charset', 'utf-8')
                        .attr('src', 'https://platform.twitter.com/widgets.js')
                        .insertAfter($(this));
                }
                if ($("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .attr('koekjetype') == "instagram") {
                    $(".instagram-media")
                        .removeClass('koekjeOff');
                    $(".instagram-media")
                        .removeClass('koekjeOff10');
                    $('<script>')
                        .attr('type', 'text/javascript')
                        .attr('async', '')
                        .attr('charset', 'utf-8')
                        .attr('src', 'https://www.instagram.com/embed.js')
                        .insertAfter($(this));
                }
                if ($("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .attr('koekjetype') == "issuu") {
                    $(".issuuembed")
                        .removeClass('koekjeOff');
                    $(".issuuembed")
                        .removeClass('koekjeOff10');
                    $('<script>')
                        .attr('type', 'text/javascript')
                        .attr('async', '')
                        .attr('charset', 'utf-8')
                        .attr('src', 'https://e.issuu.com/embed.js')
                        .insertAfter($(this));
                }
                if ($("*[koekjeid='" + $(this)
                    .attr('koekjebtn') + "']")
                    .attr('koekjetype') == "yumpu") {
                    $(".yumpuembed")
                        .removeClass('koekjeOff');
                    $(".yumpuembed")
                        .removeClass('koekjeOff10');
                    $('<script>')
                        .attr('type', 'text/javascript')
                        .attr('async', '')
                        .attr('charset', 'utf-8')
                        .attr('src', 'https://e.yumpu.com/embed.js')
                        .insertAfter($(this));
                }
                // TODO: Nicht benötigte Buttons entfernen
                var fadeout = $(this)
                    .attr('class');
                fadeout = fadeout.split(" ");
                $("button." + fadeout[1])
                    .each(function (index, el) {
                        $(this)
                            .next("*:not(.koekjeOff, .koekjeOff10)")
                            .prev("button")
                            .remove();
                    });
                if (!koekjeCookieNoTemp) {
                    
                    $("body")
                        .append(`<section id="koekjeBackground"> \
                </section> \
                <section id="koekjeWidget" class="${koekjePosition} ${koekjeMode} ${koekjeLayout}"> \
                <article> \
                <h1 class="koekjeHeadline">${koekjeAllowHeadline}</h1> \
                <p>${koekjeAllowCopy}</p> \
                <div class="tempChoice"><button class="tempConfirm" id="koekje${koekjeType}">${koekjeAllowYes}</button><button class="tempDeny" >${koekjeAllowNo}</button></div> \
                <div><label for="donotasktemp" class="switch"><input type="checkbox" name="donotasktemp" id="donotasktemp"><span class="slider round"></span></label>${koekjeAllowDoNotAsk}</div>\
                <small class="koekjeVersion"><div class="koekjeCredits">&copy; <a href="https://koekje-js.de" target="_blank">KOEKJE</a> ${koekjeVersion} | ${koekjeOrigin} | ${koekjeImprintWidget} | ${koekjePrivacyWidget}</div></small> \
                </article> \
                </section>`);
                    if (koekjeBackgroundColor) {
                        var validBackground = /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(koekjeBackgroundColor);
                        if (validBackground === true) {
                            $("#koekjeWidget > article")
                                .css("background", koekjeBackgroundColor)
                            $("#koekjeWidget button")
                                .css("background", koekjeBackgroundColor)
                        }
                    }
                    if (koekjeTextColor) {
                        var validText = /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(koekjeTextColor);
                        if (validText === true) {
                            $("#koekjeWidget *")
                                .css("color", koekjeTextColor)
                        }
                    }
                    if (koekjeButtonColor) {
                        var validText = /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(koekjeButtonColor);
                        if (validText === true) {
                            $("#koekjeWidget button")
                                .css("background", koekjeButtonColor)
                            brightness = lightOrDark(koekjeButtonColor)
                            if (brightness == 'dark') {
                                $("#koekjeWidget button")
                                    .css("color", "#fff")
                            } else {
                                $("#koekjeWidget button")
                                    .css("color", "#000")
                            }
                        }
                    }
                    if (koekjeFonts === true) {
                        $("#koekjeWidget")
                            .addClass('customfont')
                    }
                }
            });

            if (!koekjeHeadlineBool) {
                $("h1.koekjeHeadline").remove();
            }

        $("body")
            .on('click', 'button#koekjeAccordeon', function (event) {
                $("#koekjeWidget > article > section")
                    .slideToggle('fast', function () { });
            });
        $("body")
            .on('click', 'button.tempConfirm', function (event) {
                Cookies.set($(this)
                    .attr("id")
                    .toLowerCase(), 'true', {
                    expires: 365,
                    SameSite: 'lax',
                    path: '/'
                });
                location.reload();
            });
        $("body")
            .on('click', 'button.tempDeny', function (event) {
                if ($("#donotasktemp")
                    .is(':checked')) {
                    Cookies.set("koekjenotemp", "true", {
                        expires: 365,
                        SameSite: 'lax',
                        path: '/'
                    })
                }
                $("#koekjeWidget > article *")
                    .fadeOut('fast', function () {
                        $("#koekjeWidget")
                            .slideUp('fast');
                    });

                $("#koekjeWidget").remove()
                $("#koekjeBackground")
                    .remove();
            });
        $("body")
            .on('click', 'button#koekjeConfirmAll', function (event) {
                event.preventDefault();
                $("#koekjeServices input")
                    .each(function (index, el) {
                        $(this)
                            .prop('checked', true);
                    });
                Cookies.set('koekjeconfirm', 'true', {
                    expires: 365,
                    SameSite: 'lax',
                    path: '/'
                });
                $("#koekjeServices *:checked")
                    .each(function (index, el) {
                        Cookies.set($(this)
                            .attr("name")
                            .toLowerCase(), 'true', {
                            expires: 365,
                            SameSite: 'lax',
                            path: '/'
                        });
                    });
                koekjeStatsSave()
                
            });
        $("body")
            .on('click', 'button#koekjeConfirm', function (event) {
                event.preventDefault();
                Cookies.set('koekjeconfirm', 'true', {
                    expires: 365,
                    SameSite: 'lax',
                    path: '/'
                });

                



                $("#koekjeServices *:checked")
                    .each(function (index, el) {
                        Cookies.set($(this)
                            .attr("name")
                            .toLowerCase(), 'true', {
                            expires: 365,
                            SameSite: 'lax',
                            path: '/'
                        });
                    });
                koekjeStatsSave()
                
            });
        $("body")
            .on('click', 'button#koekjeReload', function (event) {
                event.preventDefault();
                Cookies.remove('koekjeconfirm');
                Cookies.remove('koekjeanalytics');
                Cookies.remove('koekjeyoutube');
                Cookies.remove('koekjesoundcloud');
                Cookies.remove('koekjevimeo');
                Cookies.remove('koekjegooglemaps');
                Cookies.remove('koekjetwitter');
                Cookies.remove('koekjefacebook');
                Cookies.remove('koekjefacebookmarketing');
                Cookies.remove('koekjeadform');
                Cookies.remove('koekjespotify');
                Cookies.remove('koekjeuserlike');
                Cookies.remove('koekjeinstagram');
                Cookies.remove('koekjeissuu');
                Cookies.remove('koekjeyumpu');
                Cookies.remove('koekjecustom1');
                Cookies.remove('koekjecustom2');
                Cookies.remove('koekjecustom3');
                Cookies.remove('koekjecustom4');
                Cookies.remove('koekjecustom5');
                Cookies.remove('koekjecustom6');
                Cookies.remove('koekjecustom7');
                Cookies.remove('koekjecustom8');
                Cookies.remove('koekjecustom9');
                Cookies.remove('koekjecustom10');
                Cookies.remove('koekjenotemp');
                location.reload();
            });
        $("body").on('click', '#koekjeBackground', function (event) {

            const myDiv = document.getElementById('koekjeWidget');

            // Add the class to the div
            myDiv.classList.add('koekjeAlertWidget');
            // TODO: Fix the initial Animation
            // // Wait for 2 seconds (2000 milliseconds)
            // setTimeout(function() {
            //   // Remove the class from the div
            //   myDiv.classList.remove('koekjeAlertWidget');
            // }, 2000);
        })
        $("body")
            .on('click keyup keypress keydown', 'label[for="koekjeEssential"]', function (event) {
                event.preventDefault()
            });
        $("body")
            .on('click keyup keypress keydown', '#koekjeDetailChoice', function (event) {
                if ($("#koekjeServices")
                    .is(':visible')) {
                        $("#koekjeDetailChoice").removeClass("KoekjeopenButton")
                    $("#koekjeServices").removeClass("KoekjeServicesOpen");
                } else {
                    $("#koekjeDetailChoice").addClass("KoekjeopenButton")
                    $("#koekjeServices").addClass("KoekjeServicesOpen");
                }
            });
        $("body")
            .on('click keyup keypress keydown', 'label[for="koekjeStatistics"], #koekjeStatistics', function (event) {
                var state = $('#koekjeStatistics')
                    .prop('checked');
                 
                if (state == false) {
                    $('#koekjeAnalytics:not(.KoekjeEssential)')
                        .prop('checked', false);
                        $('#koekjeAdform:not(.KoekjeEssential)')
                        .prop('checked', false);   
                 
                } else if (state == true) {
                    $('#koekjeAnalytics:not(.KoekjeEssential)')
                        .prop('checked', true);
                        $('#koekjeAdform:not(.KoekjeEssential)')
                        .prop('checked', true);    
                        
                }
            });
        $("body")
            .on('click keyup keypress keydown', 'label[for="koekjeExtMedia"], #koekjeExtMedia', function (event) {
                var state = $('#koekjeExtMedia')
                    .prop('checked');
                if (state == false) {
                    $('#koekjeYouTube:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeSoundCloud:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeTwitter:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeVimeo:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeSpotify:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeInstagram:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeIssuu:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeYumpu:not(.KoekjeEssential)')
                        .prop('checked', false);
                } else if (state == true) {
                    $('#koekjeYouTube:not(.KoekjeEssential)')
                        .prop('checked', true)
                    $('#koekjeSoundCloud')
                        .prop('checked', true)
                    $('#koekjeTwitter:not(.KoekjeEssential)')
                        .prop('checked', true);
                    $('#koekjeVimeo:not(.KoekjeEssential)')
                        .prop('checked', true)
                    $('#koekjeSpotify:not(.KoekjeEssential)')
                        .prop('checked', true);
                    $('#koekjeInstagram:not(.KoekjeEssential)')
                        .prop('checked', true);
                    $('#koekjeIssuu:not(.KoekjeEssential)')
                        .prop('checked', true);
                    $('#koekjeYumpu:not(.KoekjeEssential)')
                        .prop('checked', true);
                }
            });
        $("body")
            .on('click keyup keypress keydown', 'label[for="koekje3rdParty"], #koekje3rdParty', function (event) {
                var state = $('#koekje3rdParty')
                    .prop('checked');
                if (state == false) {
                    $('#koekjeFacebook:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeFacebookMarketing:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeGoogleMaps:not(.KoekjeEssential)')
                        .prop('checked', false);
                    $('#koekjeUserlike:not(.KoekjeEssential)')
                        .prop('checked', false);
                } else if (state == true) {
                    $('#koekjeFacebook:not(.KoekjeEssential)')
                        .prop('checked', true);
                    $('#koekjeFacebookMarketing:not(.KoekjeEssential)')
                        .prop('checked', true);
                    $('#koekjeGoogleMaps:not(.KoekjeEssential)')
                        .prop('checked', true);
                    $('#koekjeUserlike:not(.KoekjeEssential)')
                        .prop('checked', true);
                }
            });
    }
        /*!
         * JavaScript Cookie v2.2.0
         * https://github.com/js-cookie/js-cookie
         *
         * Copyright 2006, 2015 Klaus Hartl & Fagner Brack
         * Released under the MIT license
         */
        ;
    (function (factory) {
        var registeredInModuleLoader = false;
        if (typeof define === 'function' && define.amd) {
            define(factory);
            registeredInModuleLoader = true;
        }
        if (typeof exports === 'object') {
            module.exports = factory();
            registeredInModuleLoader = true;
        }
        if (!registeredInModuleLoader) {
            var OldCookies = window.Cookies;
            var api = window.Cookies = factory();
            api.noConflict = function () {
                window.Cookies = OldCookies;
                return api;
            };
        }
    }(function () {
        function extend() {
            var i = 0;
            var result = {};
            for (; i < arguments.length; i++) {
                var attributes = arguments[i];
                for (var key in attributes) {
                    result[key] = attributes[key];
                }
            }
            return result;
        }

        function init(converter) {
            function api(key, value, attributes) {
                var result;
                if (typeof document === 'undefined') {
                    return;
                }
                if (arguments.length > 1) {
                    attributes = extend({
                        path: '/'
                    }, api.defaults, attributes);
                    if (typeof attributes.expires === 'number') {
                        var expires = new Date();
                        expires.setMilliseconds(expires.getMilliseconds() + attributes.expires * 864e+5);
                        attributes.expires = expires;
                    }
                    attributes.expires = attributes.expires ? attributes.expires.toUTCString() : '';
                    try {
                        result = JSON.stringify(value);
                        if (/^[\{\[]/.test(result)) {
                            value = result;
                        }
                    } catch (e) { }
                    if (!converter.write) {
                        value = encodeURIComponent(String(value))
                            .replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g, decodeURIComponent);
                    } else {
                        value = converter.write(value, key);
                    }
                    key = encodeURIComponent(String(key));
                    key = key.replace(/%(23|24|26|2B|5E|60|7C)/g, decodeURIComponent);
                    key = key.replace(/[\(\)]/g, escape);
                    var stringifiedAttributes = '';
                    for (var attributeName in attributes) {
                        if (!attributes[attributeName]) {
                            continue;
                        }
                        stringifiedAttributes += '; ' + attributeName;
                        if (attributes[attributeName] === true) {
                            continue;
                        }
                        stringifiedAttributes += '=' + attributes[attributeName];
                    }
                    return (document.cookie = key + '=' + value + stringifiedAttributes);
                }
                if (!key) {
                    result = {};
                }
                var cookies = document.cookie ? document.cookie.split('; ') : [];
                var rdecode = /(%[0-9A-Z]{2})+/g;
                var i = 0;
                for (; i < cookies.length; i++) {
                    var parts = cookies[i].split('=');
                    var cookie = parts.slice(1)
                        .join('=');
                    if (!this.json && cookie.charAt(0) === '"') {
                        cookie = cookie.slice(1, -1);
                    }
                    try {
                        var name = parts[0].replace(rdecode, decodeURIComponent);
                        cookie = converter.read ? converter.read(cookie, name) : converter(cookie, name) || cookie.replace(rdecode, decodeURIComponent);
                        if (this.json) {
                            try {
                                cookie = JSON.parse(cookie);
                            } catch (e) { }
                        }
                        if (key === name) {
                            result = cookie;
                            break;
                        }
                        if (!key) {
                            result[name] = cookie;
                        }
                    } catch (e) { }
                }
                return result;
            }
            api.set = api;
            api.get = function (key) {
                return api.call(api, key);
            };
            api.getJSON = function () {
                return api.apply({
                    json: true
                }, [].slice.call(arguments));
            };
            api.defaults = {};
            api.remove = function (key, attributes) {
                api(key, '', extend(attributes, {
                    expires: -1
                }));
            };
            api.withConverter = init;
            return api;
        }
        return init(function () { });
    }));

    function lightOrDark(color) {
        var r, g, b, hsp;
        if (color.match(/^rgb/)) {
            color = color.match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/);
            r = color[1];
            g = color[2];
            b = color[3];
        } else {
            color = +("0x" + color.slice(1)
                .replace(color.length < 5 && /./g, '$&$&'));
            r = color >> 16;
            g = color >> 8 & 255;
            b = color & 255;
        }
        hsp = Math.sqrt(0.299 * (r * r) + 0.587 * (g * g) + 0.114 * (b * b));
        if (hsp > 127.5) {
            return 'light';
        } else {
            return 'dark';
        }
    }

});

function koekjeStatsSave() {
    
        var checkedArray = [];
        var uncheckedArray = [];
      
        var checkboxes = document.querySelectorAll('#koekjeServices input[type="checkbox"]')
      
        checkboxes.forEach(function(checkbox) {
            var label = checkbox.parentNode;
            var labelText = label.nextSibling.textContent.trim();
          if (checkbox.checked) {
            checkedArray.push(labelText);
          } else {
            uncheckedArray.push(labelText);
          }
        });
      
        var button = document.getElementById('koekjeReload');
        var koekjeId = button.getAttribute('koekje_id');

        var data = {
          checked: checkedArray,
          unchecked: uncheckedArray,
          url: window.location.href,
          koekje_id: koekjeId
        };
      
        console.log(koekjeId)
        var xhr = new XMLHttpRequest();
        xhr.open("POST", "https://cdn.koekje-js.de/stats/", true);
        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        xhr.onreadystatechange = function() {
            if (xhr.readyState === XMLHttpRequest.DONE) {
                if (xhr.status === 200) {
                  location.reload();
                } else {
               
                }
              }
        };
      
        xhr.send(JSON.stringify(data));
  }
  